<?php

define('DB_NAME', '');
define('DB_HOST', 'yoursite.com');
define('DB_USERNAME', '');
define('DB_PASSWORD', '');
// if records not readeble then make it true
/**
 * default false. if records not readeble then make it true. suffested values per scipt
 * 		xzero => true
 */
define('DB_NO_UTF8', true);
define('TABLE_PREFIX', 'nz_');
define('IMAGE_URL_PREFIX', 'http://yoursite.com/adpics/');

/**
 * Valid scripts : xzero
 * 	
 */
define('SCRIPT_NAME', 'xzero');



/* setup dev user by ip. good to test on live server */
$arr_myip = array('127.0.0.1', '78.38.241.32');

function is_dev()
{
	global $arr_myip;
	if(defined('REMOTE_ADDR'))
	{
		return in_array(REMOTE_ADDR, $arr_myip);
	}
	return false;
}

// if mod rewrite works then define questy string
// $_SERVER['QUERY_STRING'] = $_SERVER['REQUEST_URI'];



$connections = array(
	'master' => array('DB_DSN' => 'mysql:dbname=' . DB_NAME . ';host=' . DB_HOST,
		'DB_USER' => DB_USERNAME,
		'DB_PASS' => DB_PASSWORD,
		'DB_NO_UTF8' => DB_NO_UTF8
	)
);


// user ve blogbilgisi bu tabloda. diller tablosu blog tablosundaki dilsecenegine gore degisir.
define('MAIN_DB', 'master');


define('REQUEST_TIME', $_SERVER['REQUEST_TIME']);
define('REMOTE_ADDR', $_SERVER['REMOTE_ADDR']);
define('DEMO', 0);

// if developer then 
if(is_dev())
{
	define('DEBUG', true);
// turn error reporting on 
	error_reporting(E_ALL);
	ini_set('display_errors', '1');
}
else
{
	define('DEBUG', false);
}

// if your server doesn't have PDO (with MySQL driver) set the below to false
define('USE_PDO', '1');

// Set the timezone of your choise
// go here for more information of the available timezone:
// http://php.net/timezones GMT
define('DEFAULT_TIMEZONE', 'GMT');


// include framework
include 'Framework.php';

// set DB connection 
Record::$__CONNECTIONS__ = $connections;

// set page
$page = intval($_GET['page']);
if($page < 1)
{
	$page = 1;
}
$num = 10;
$st = ($page - 1) * $num;

// connect 
switch(SCRIPT_NAME)
{
	case 'xzero':

		if(!Record::getConnection('master'))
		{
			exit;
		}
		//echo '[SCRIPT_NAME:' . SCRIPT_NAME . ']';

		$ads = Record::findAllFrom('Ads', '1=1 ORDER BY adid LIMIT ' . $st . ',' . $num);

		// append images 
		Record::appendObject($ads, 'adid', 'Adpics', 'adid', '', 'master', '*', false, true);

		// append city
		Record::appendObject($ads, 'cityid', 'Cities', 'cityid');

		// append country
		$cities = array();
		foreach($ads as $ad)
		{
			$cities[$ad->cityid] = $ad->Cities;
		}
		Record::appendObject($cities, 'countryid', 'Countries', 'countryid');

		// append subcategory 
		Record::appendObject($ads, 'subcatid', 'Subcats', 'subcatid');

		// append category
		$subcats = array();
		foreach($ads as $ad)
		{
			$subcats[$ad->subcatid] = $ad->Subcats;
		}
		Record::appendObject($subcats, 'catid', 'Cats', 'catid');

		// appned fields
		Record::appendObject($subcats, 'subcatid', 'Subcatxfields', 'subcatid', '', 'master', '*', false, true);
		// append ad field values
		Record::appendObject($ads, 'adid', 'Adxfields', 'adid');

		// define values 
		$arr_show_email = array(
			'0' => 'hide',
			'1' => 'show',
			'2' => 'form',
		);
		$arr_custom_field_type = array(
			'S' => 'text',
			'N' => 'number',
			'D' => 'dropdown',
		);
		$link = '';

		header("Content-Type: application/xml; charset=UTF-8");

		echo '<?xml version="1.0" encoding="UTF-8" ?>
			<rss version="2.0">
				<channel>
					<title>SCRIPT_NAME:' . SCRIPT_NAME . '</title>
				    <description>Export xml. current page:' . $page . ' . to load next page use ?page=' . ($page + 1) . '</description>
				';

		foreach($ads as $ad)
		{
			// images 
			$images = array();
			if($ad->Adpics)
			{
				foreach($ad->Adpics as $adpic)
				{
					$images[] = '<image>' . IMAGE_URL_PREFIX . $adpic->picfile . '</image>
								';
				}
			}

			// custom fields
			$custom_fields = array();
			$phone = '';
			if($ad->Subcats->hasprice)
			{
				$custom_fields[] = '<customfield>
										<name>' . View::escape($ad->Subcats->pricelabel) . '</name>
										<value>' . View::escape($ad->price) . '</value>
										<type>price</type>
										<defined></defined>
										<is_search>1</is_search>
										<is_list>1</is_list>
									</customfield>
									';
			}
			if($ad->Subcats->Subcatxfields)
			{
				foreach($ad->Subcats->Subcatxfields as $field)
				{
					$value = View::escape($ad->Adxfields->{'f' . $field->fieldnum});
					if($phone == '' && strtolower($field->name) == 'phone')
					{
						// add to ad contact field
						$phone = '<phone>' . $value . '</phone>';
						continue;
					}

					$custom_fields[] = '<customfield>
										<name>' . View::escape($field->name) . '</name>
										<value>' . $value . '</value>
										<type>' . $arr_custom_field_type[$field->type] . '</type>
										<defined>' . ($field->vals ? formatValues(explode(';', $field->vals)) : '') . '</defined>
										<is_search>' . intval($field->showinlist) . '</is_search>
										<is_list>' . intval($field->searchable) . '</is_list>
									</customfield>
									';
				}
			}

			// $link = Ad::url($ad);			
			echo '<item>
					<title>' . View::escape($ad->adtitle) . '</title>
					<link>' . $link . '</link>
					<description>' . View::escape($ad->addesc) . '</description>		
					<pubDate>' . date('r', strtotime($ad->createdon)) . '</pubDate>
					<verified>' . intval($ad->verified) . '</verified>
					<enabled>' . intval($ad->enabled) . '</enabled>
					<email>' . View::escape($ad->email) . '</email>
					<showemail>' . $arr_show_email[$ad->showemail] . '</showemail>
					' . $phone . '
					<ip>' . View::escape($ad->ip) . '</ip>
					<location>' . formatValues(array($ad->Cities->Countries->countryname, $ad->Cities->cityname)) . '</location>
					<category>' . formatValues(array($ad->Subcats->Cats->catname, $ad->Subcats->subcatname)) . '</category>
					' . implode('', $images) . implode('', $custom_fields) . '
				</item>
				';
		}

		echo '</channel>
			</rss>';




		//print_r($ads);
		//exit;
		break;
	default :
		exit(SCRIPT_NAME . ' script not supported.');
}

function formatValues($array = array())
{
	$arr_ = array();
	if($array)
	{
		foreach($array as $val)
		{
			if(strlen(trim($val)) > 0)
			{
				$arr_[] = View::escape($val);
			}
		}
	}

	if($arr_)
	{

		return '<val>' . implode('</val><val>', $arr_) . '</val>';
	}
	return '';
}

//display_benchmark();